<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResumoRetencaoLiqERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfResumoRetencaoLiqERP
 * @subpackage Arrays
 */
class ArrayOfResumoRetencaoLiqERP extends AbstractStructArrayBase
{
    /**
     * The ResumoRetencaoLiqERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ResumoRetencaoLiqERP[]
     */
    public $ResumoRetencaoLiqERP;
    /**
     * Constructor method for ArrayOfResumoRetencaoLiqERP
     * @uses ArrayOfResumoRetencaoLiqERP::setResumoRetencaoLiqERP()
     * @param \StructType\ResumoRetencaoLiqERP[] $resumoRetencaoLiqERP
     */
    public function __construct(array $resumoRetencaoLiqERP = array())
    {
        $this
            ->setResumoRetencaoLiqERP($resumoRetencaoLiqERP);
    }
    /**
     * Get ResumoRetencaoLiqERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ResumoRetencaoLiqERP[]|null
     */
    public function getResumoRetencaoLiqERP()
    {
        return isset($this->ResumoRetencaoLiqERP) ? $this->ResumoRetencaoLiqERP : null;
    }
    /**
     * Set ResumoRetencaoLiqERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ResumoRetencaoLiqERP[] $resumoRetencaoLiqERP
     * @return \ArrayType\ArrayOfResumoRetencaoLiqERP
     */
    public function setResumoRetencaoLiqERP(array $resumoRetencaoLiqERP = array())
    {
        foreach ($resumoRetencaoLiqERP as $arrayOfResumoRetencaoLiqERPResumoRetencaoLiqERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfResumoRetencaoLiqERPResumoRetencaoLiqERPItem instanceof \StructType\ResumoRetencaoLiqERP) {
                throw new \InvalidArgumentException(sprintf('The ResumoRetencaoLiqERP property can only contain items of \StructType\ResumoRetencaoLiqERP, "%s" given', is_object($arrayOfResumoRetencaoLiqERPResumoRetencaoLiqERPItem) ? get_class($arrayOfResumoRetencaoLiqERPResumoRetencaoLiqERPItem) : gettype($arrayOfResumoRetencaoLiqERPResumoRetencaoLiqERPItem)), __LINE__);
            }
        }
        if (is_null($resumoRetencaoLiqERP) || (is_array($resumoRetencaoLiqERP) && empty($resumoRetencaoLiqERP))) {
            unset($this->ResumoRetencaoLiqERP);
        } else {
            $this->ResumoRetencaoLiqERP = $resumoRetencaoLiqERP;
        }
        return $this;
    }
    /**
     * Add item to ResumoRetencaoLiqERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ResumoRetencaoLiqERP $item
     * @return \ArrayType\ArrayOfResumoRetencaoLiqERP
     */
    public function addToResumoRetencaoLiqERP(\StructType\ResumoRetencaoLiqERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResumoRetencaoLiqERP) {
            throw new \InvalidArgumentException(sprintf('The ResumoRetencaoLiqERP property can only contain items of \StructType\ResumoRetencaoLiqERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ResumoRetencaoLiqERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ResumoRetencaoLiqERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ResumoRetencaoLiqERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ResumoRetencaoLiqERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ResumoRetencaoLiqERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ResumoRetencaoLiqERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResumoRetencaoLiqERP
     */
    public function getAttributeName()
    {
        return 'ResumoRetencaoLiqERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfResumoRetencaoLiqERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
